

import java.io.FileNotFoundException;
import java.util.Scanner;

import Src.Algo;
import Src.Graphe;
import Src.LecteurAretes;
import Src.LecteurSommets;
import Src.LecteurStations;
import Src.petitGraphe;


public class InterfaceConsole {

	/**
	 * @param args
	 * @throws FileNotFoundException 
	 */
	public static void main(String[] args) throws FileNotFoundException {

		Scanner sc = new Scanner (System.in);

		int choix = -1;
		int[] composantesConnexes = null;
		String[] villes = new String[2];
		String entree;
		Graphe graph =null;
		petitGraphe petitgraph = null;
		while(choix != 0){
			afficherMenu();
 
			entree= sc.next();
			choix = Integer.valueOf(entree);
			
			switch (choix){
			case 1 :
				int nbSommet = LecteurSommets.lireNbSommet("./Src/france.sommets");
				graph = new Graphe(nbSommet, null);
				System.out.println("Nombre de sommets : "+ nbSommet);
				LecteurSommets.lireSommet("./Src/france.sommets", graph);
				System.out.println("Sommets charges");
				LecteurAretes.lireAretes("./Src/france.aretes",graph);
				System.out.println("Aretes chargees");
				int nbStations = LecteurStations.nbStations("./Src/france.stations");
				petitgraph = new petitGraphe(nbStations, graph);
				System.out.println("Nombre de stations : "+ nbStations);
				LecteurStations.lireStation("./Src/france.stations", petitgraph);
			    System.out.println("Stations chargees");
				break;
				
			case 2 : 
				composantesConnexes = Algo.calculConnexite(graph);
				int nb = Algo.isConnexe(composantesConnexes);
				if( nb == 1) System.out.println("Le graphe est connexe");
				else  System.out.println("Le graphe n'est pas connexe ("+nb+" composantes)");
				System.out.println("Construction du graphe des stations");
				Algo.construirePetitGraphe(graph,petitgraph,composantesConnexes);
				System.out.println("Graphe termine");
				break;
			case 3 :
				if(composantesConnexes == null) System.out.println("\nVeuillez d'abord calculer les composantes connexes!\n");
				else{
					villes = choixVilles(sc);
					Algo.plusCourtChemin(villes[0],villes[1],graph,petitgraph,"distance",composantesConnexes,"normal");
				}
				break;
				
			case 4 :
				if(composantesConnexes == null) System.out.println("\nVeuillez d'abord calculer les composantes connexes!\n");
				else{
					villes = choixVilles(sc);
//					System.out.println("\nVille 1 : "+villes[0]+" et ville 2 : "+villes[1]);
					Algo.plusCourtChemin(villes[0],villes[1],graph,petitgraph,"distance",composantesConnexes,"tas");
				}
				break;
			case 5 : 
				if(composantesConnexes == null) System.out.println("\nVeuillez d'abord calculer les composantes connexes!\n");
				else{
					villes = choixVilles(sc);
//					System.out.println("\nVille 1 : "+villes[0]+" et ville 2 : "+villes[1]);
					Algo.plusCourtChemin(villes[0],villes[1],graph,petitgraph,"distance",composantesConnexes,"contraint");
					
					//on reconstruit le graphe pour virer les deux sommets ajoutes
					nbStations = LecteurStations.nbStations("./Src/france.stations");
					petitgraph = new petitGraphe(nbStations, graph);
					LecteurStations.lireStation("./Src/france.stations", petitgraph);
					Algo.construirePetitGraphe(graph,petitgraph,composantesConnexes);
				}
				
				break;
			case 0 : 
				System.out.println("\nMerci d'avoir fait un petit tour sur notre interface!!!\n");
				break;
			}
		}

	}
	
	private static void afficherMenu(){
		System.out.println();
		System.out.println("-----------------MENU-----------------");
		System.out.println("1- Charger le Graphe.");
		System.out.println("2- Vérification de la connexité.");
		System.out.println("3- Calcul du plus court chemin simple.");
		System.out.println("4- calcul du plus court chemin optimisé.");
		System.out.println("5- calcul du plus court chemin optimisé avec prise en compte de l'autonomie.");
		System.out.println("0- Quitter.");
		System.out.print("Votre choix : ");
	}
	
	private static String[] choixVilles(Scanner sc){
		String[] villes = new String[2];
		System.out.print("\nVille de départ : ");
		villes[0] =  sc.next();
		System.out.print("\nVille d'arrivée : ");
		villes[1] =  sc.next();
		return villes;
	}

}
